'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formsyReact = require('formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _reactBootstrap = require('react-bootstrap');

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propUtilities = require('./propUtilities');

/*
@Todo : Gérer les groups
*/

var Select = _react2.default.createClass({
  displayName: 'Select',


  mixins: [_formsyReact2.default.Mixin, _mixins2.default],

  componentDidMount: function componentDidMount() {
    if (!this.getValue()) {
      this.setValue(this.props.options[0].value);
    }
  },

  changeValue: function changeValue(event) {
    var value = void 0;
    var target = event.currentTarget;
    if (this.props.multiple) {
      value = [];
      for (var i = 0; i < target.length; i++) {
        var option = target.options[i];
        if (option.selected) {
          value.push(option.value);
        }
      }
    } else {
      value = target.value;
    }
    this.setValue(value);
    this.props.onChange(this.props.name, value);
  },

  renderElement: function renderElement() {
    var _this = this;

    var renderOption = function renderOption(item, key) {
      var group = item.group,
          label = item.label,
          rest = _objectWithoutProperties(item, ['group', 'label']);

      return _react2.default.createElement(
        'option',
        _extends({ key: key }, rest),
        item.label
      );
    };

    var options = this.props.options;

    var optionNodes = [];

    optionNodes = options.map(function (item, index) {
      return renderOption(item, index);
    });

    return _react2.default.createElement(
      _reactBootstrap.FormControl,
      _extends({}, propUtilities.cleanProps(this.props), {
        ref: function ref(c) {
          return _this.element = c;
        },
        onChange: this.changeValue,
        componentClass: 'select',
        value: this.getValue(),
        multiple: this.props.multiple ? "multiple" : ''
      }),
      optionNodes
    );
  },
  render: function render() {
    if (this.props.elementOnly) return this.renderElement();

    var Layout = this.getLayout();
    return _react2.default.createElement(Layout.Select, { element: this });
  }
});

module.exports = Select;