const path = require('path');
const webpack = require('webpack')

const PATHS = {
  app: path.join(__dirname, 'demo/src'),
  build: path.join(__dirname, 'demo/build')
};

module.exports = {
  entry: [
    'bootstrap-loader',
    PATHS.app
  ],
  output: {
    path: PATHS.build,
    filename: '[name].js'
  },
  plugins: [
    new webpack.ProvidePlugin({
      $: "jquery",
      jQuery: "jquery",
      "window.jQuery": "jquery"
    })
  ],
  module: {
    loaders: [
      {
        test: /\.js$/,
        loaders: [ 'babel' ],
        exclude: /node_modules/,
        include: __dirname
      },
      {
        test: /\.scss$|.css$/,
        loader: "style-loader!css-loader!sass-loader"
      },
      {
        test: /\.woff($|\?)|\.woff2($|\?)|\.ttf($|\?)|\.eot($|\?)|\.svg($|\?)/,
        loader: 'url-loader'
      }
    ]
  }
};
